/*
 * reflection.js v1.6
 *
 * Contributors: Cow http://cow.neondragon.net
 *               Gfx http://www.jroller.com/page/gfx/
 *               Sitharus http://www.sitharus.com
 *               Andreas Linde http://www.andreaslinde.de
 *               Tralala, coder @ http://www.vbulletin.org
 *
 * Freely distributable under MIT-style license.
 */
/*
 * 以下のコードは、SF Skin (http://gekko.kagennotuki.com/) での使用を目的として Gekko が抜粋及び変更したものです。
 * reflection.js のオリジナルは右記のサイトに有ります。 http://cow.neondragon.net/stuff/reflection/
 */

var Reflection = {
	defaultHeight : 0.5,
	defaultOpacity: 0.5,
	add: function(image, options) {
		Reflection.remove(image);
		doptions = { "height" : Reflection.defaultHeight, "opacity" : Reflection.defaultOpacity }
		if (options) {for (var i in doptions) if (!options[i]) options[i] = doptions[i];}
		else {options = doptions;}
		var d = document.createElement('div'), p = image;
		var reflectionWidth = p.id ? p.width : p.width + 2;
		var reflectionHeight = Math.floor(p.height*options['height']);
		var divHeight = Math.floor(p.height*(1+options['height']));
		var canvas = document.createElement('canvas'), context = canvas.getContext("2d");
		d.className = 'reflexunit'; p.style.cssText += 'vertical-align: bottom';
		canvas.style.height = reflectionHeight+'px'; canvas.style.width = reflectionWidth+'px';
		canvas.height = reflectionHeight; canvas.width = reflectionWidth;
		p.parentNode.replaceChild(d, p); d.appendChild(p); d.appendChild(canvas);
		context.save(); context.translate(0,image.height-1); context.scale(1,-1);
		context.drawImage(image, 0, 0, reflectionWidth, image.height); context.restore();
		context.globalCompositeOperation = "destination-out";
		var gradient = context.createLinearGradient(0, 0, 0, reflectionHeight);
		gradient.addColorStop(1, "rgba(255, 255, 255, 1.0)");
		gradient.addColorStop(0, "rgba(255, 255, 255, "+(1-options['opacity'])+")");
		context.fillStyle = gradient; context.fill();
	},
	remove : function(image) {
		if (image.parentNode.className == 'reflexunit')
		    image.parentNode.parentNode.replaceChild(image, image.parentNode);
	}
}
